<?php
/*
Extension Name: JQuery
Extension Url: http://vanillaforums.org/addon/231
Description: jQuery JavaScript Library version 1.6.1. Must be enabled BEFORE all other "JQ Extensions". Requires Set List for Administration Extension Options.
Version: v20-1.6.1
Author: Luke Scammell aka [-Stash-]
Author Url: http://scammell.co.uk/
*/
	if(!isset($Head)) return;

	// a little security
	if (!defined('IN_VANILLA')) exit();
	define('JQUERY_EXTENSION', true);
	$JQPath = 'extensions/JQuery/';
	$JQPPath = 'extensions/JQuery/plugins/';
	// Please don't mess with these unless you know what you're doing, otherwise you can break update version checking
	$JQext = 'v20-1.6.1';
	$JQjs = '1.6.1';

	// Set the Extension version number.
	if (!array_key_exists('JQUERY_VERSION_EXT', $Configuration) || ($Configuration['JQUERY_VERSION_EXT'] != $JQext)) {
		AddConfigurationSetting($Context, 'JQUERY_VERSION_EXT', $JQext);}
	// Set the JavaScript version number.
	if (!array_key_exists('JQUERY_VERSION_JS', $Configuration) || ($Configuration['JQUERY_VERSION_JS'] != $JQjs)) {
		AddConfigurationSetting($Context, 'JQUERY_VERSION_JS', $JQjs);}
	// Specify which jQuery library to use
	if(!array_key_exists('JQUERY_FILE_TYPE', $Configuration)) {
		AddConfigurationSetting($Context, 'JQUERY_FILE_TYPE', '0');}
	/*	Plugins
	 *	Check to see if there are already config setting switches set for each plugin, and if not, create one and default it to off
	 */	
	if(!array_key_exists('JQUERY_PLUGIN_COLORBOX', $Configuration)) {
		AddConfigurationSetting($Context, 'JQUERY_PLUGIN_COLORBOX', '0');}
	if(!array_key_exists('JQUERY_PLUGIN_HIDESPOILER', $Configuration)) {
		AddConfigurationSetting($Context, 'JQUERY_PLUGIN_HIDESPOILER', '0');}
	if(!array_key_exists('JQUERY_PLUGIN_SMOOTHPAGESCROLL', $Configuration)) {
		AddConfigurationSetting($Context, 'JQUERY_PLUGIN_SMOOTHPAGESCROLL', '0');}
	if(!array_key_exists('JQUERY_PLUGIN_CKEDITOR', $Configuration)) {
		AddConfigurationSetting($Context, 'JQUERY_PLUGIN_CKEDITOR', '0');}
	function includeJQuery() {
		if(defined('JQUERY_INCLUDED')) return;
		global $Head, $Configuration, $Context, $JQPath;
		// Default - Current minified
		if ($Context->Configuration['JQUERY_FILE_TYPE'] == '0')			{$Head->AddScript($JQPath.'jquery-1.6.1.min.js');}
		// Development Mode - Current uncompressed
		elseif ($Context->Configuration['JQUERY_FILE_TYPE'] == '999')	{$Head->AddScript($JQPath.'jquery-1.6.1.js');}
		// Previously Released - Uncompressed
		// Not having jQuery 1.6.0 because it changed/broke a whle lod of stuff.
		elseif ($Context->Configuration['JQUERY_FILE_TYPE'] == '998')	{$Head->AddScript($JQPath.'old/jquery-1.5.2.js');}
		// Old Version - 1.0 minified
		elseif ($Context->Configuration['JQUERY_FILE_TYPE'] == '1')		{$Head->AddScript($JQPath.'old/jquery-1.0.4.min.js');}
		// Old Version - 1.1 minified
		elseif ($Context->Configuration['JQUERY_FILE_TYPE'] == '2')		{$Head->AddScript($JQPath.'old/jquery-1.1.4.min.js');}
		// Old Version - 1.2 minified
		elseif ($Context->Configuration['JQUERY_FILE_TYPE'] == '3')		{$Head->AddScript($JQPath.'old/jquery-1.2.6.min.js');}
		// Old Version - 1.3 minified
		elseif ($Context->Configuration['JQUERY_FILE_TYPE'] == '4')		{$Head->AddScript($JQPath.'old/jquery-1.3.2.min.js');}
		// Old Version - 1.4 minified
		elseif ($Context->Configuration['JQUERY_FILE_TYPE'] == '5')		{$Head->AddScript($JQPath.'old/jquery-1.4.2.min.js');}
		// Old Version - 1.5 minified
		elseif ($Context->Configuration['JQUERY_FILE_TYPE'] == '6')		{$Head->AddScript($JQPath.'old/jquery-1.5.2.min.js');}
		define('JQUERY_INCLUDED', true);
	}

// ColorBox
// if (in_array($Context->SelfUrl, array('account.php','categories.php','comments.php','extension.php','index.php','people.php','post.php','search.php','settings.php','termsofservice.php'))) {
  if ($Context->Configuration['JQUERY_PLUGIN_COLORBOX'] == '1') {
   includeJQuery(); // call JQuery to ensure it's loaded first 
   $Head->AddStylesheet	($JQPPath.'colorbox/colorbox.css');
   $Head->AddScript		($JQPPath.'colorbox/jquery.colorbox-min.js');
   $Head->AddScript		($JQPPath.'colorbox/jquery.colorbox.functions.js');
  }
// }

// HideSpoiler
	if ($Context->Configuration['JQUERY_PLUGIN_HIDESPOILER'] == '1') {
		if(in_array($Context->SelfUrl, array("comments.php", "post.php"))) {
			includeJQuery(); // call JQuery to ensure it's loaded first 
			$Head->AddStylesheet	($JQPPath.'HideSpoiler/HideSpoiler.css');
			$Head->AddScript		($JQPPath.'HideSpoiler/HideSpoiler.js');
			if(!defined('IN_VANILLA')) exit();
			class HideSpoiler extends StringFormatter {
			function Parse ($String, $Object, $FormatPurpose) {
				global $Configuration;
				$CommentList = &$CommentGrid->DelegateParameters["CommentList"];
					$sReturn = $String;
					if($FormatPurpose  == FORMAT_STRING_FOR_DISPLAY) { // This is what you type in the comment box
						$Patterns		= array("/\[hide\](.+?)\[\/hide\]/is");
						$Replacements	= array('<span class="hidden">$1</span>');
						$sReturn = preg_replace($Patterns, $Replacements, $sReturn);
					}
					return $sReturn;
				}
			}
			// Global StringFormatter
			$HideSpoiler = $Context->ObjectFactory->NewObject($Context, "HideSpoiler");
			$Context->StringManipulator->AddGlobalManipulator("HideSpoiler", $HideSpoiler);
		}
	}

// SmoothPageScroll
// if (in_array($Context->SelfUrl, array('account.php','categories.php','comments.php','extension.php','index.php','people.php','post.php','search.php','settings.php','termsofservice.php'))) {
	if ($Context->Configuration['JQUERY_PLUGIN_SMOOTHPAGESCROLL'] == '1') {
		includeJQuery(); // call JQuery to ensure it's loaded first 
		$Head->AddScript($JQPPath.'SmoothPageScroll/SmoothPageScroll.js');
	}
// }

// CKEditor
if ($Context->Configuration['JQUERY_PLUGIN_CKEDITOR'] == '1') {
	if (in_array($Context->SelfUrl, array('comments.php','post.php'))) {	/* [-Stash-] 2010-03-24 17:20:01 - Reduces the load on other pages. Are there any other pages this might need to show up? */
		includeJQuery(); // call JQuery to ensure it's loaded first 
		$Head->AddScript($JQPPath.'ckeditor/ckeditor.js');
		$Head->AddScript($JQPPath.'ckeditor/adapters/jquery.js');
		$Head->AddScript($JQPPath.'ckeditor/ckeditor.config.js');
	}
}

// Quote - Start working on this some time... [-Stash-] 2010-02-24 17:29:45
// if (in_array($Context->SelfUrl, array('account.php','categories.php','comments.php','extension.php','index.php','people.php','post.php','search.php','settings.php','termsofservice.php'))) {
	// if ($Context->Configuration['JQUERY_PLUGIN_CKEDITOR'] == '1') {
		// includeJQuery(); // call JQuery to ensure it's loaded first 
		// $Head->AddScript($JQPPath.'quote/quote.js');
	// }
// }
?>